#include "main.h"

double **Get_Transformation_Matrix()
{
   char    *Subroutine_Name = "Get_Transformation_Matrix()";
   double **Transformation_Matrix;
   double  *Pointer;
   int      i;
   int      Index;

   if ((Transformation_Matrix = (double **) malloc(sizeof(double *) * 4))
      == NULL)
   {
      printf("%s -- can not allocate Transformation Matrix. Abort!\n",
             Subroutine_Name);
      exit(1);
   }

   if ((Pointer = (double *) malloc(sizeof(double) * 4 * 4)) == NULL)
   {
      printf("%s -- can not allocate View Transformation Matrix. Abort!\n",
             Subroutine_Name);
      exit(1);
   }

   for (i = 0, Index = 0; i < 4; i++, Index += 4)
      Transformation_Matrix[i] = &(Pointer[Index]);

   return(Transformation_Matrix);
}

world *Get_World_Info(int Num_Polygons, int Num_Vertices)
{
   char    *Subroutine_Name = "Get_World_Info()";
   world   *World;
   polygon *Polygons;
   vertex  *Vertices;
   int      i;
   int      Index;

   if ((World = (world *) malloc(sizeof(world))) == NULL)
   {
      printf("%s -- can not allocate world. Abort!\n", Subroutine_Name);
      exit(1);
   }

   World -> Num_Polygons = Num_Polygons;
   World -> Max_Vertices_per_Polygon = Num_Vertices;

#ifdef DEBUG_GET_WORLD_INFO
   printf("%s - World = 0x%lx\n", Subroutine_Name, World);
#endif

   if ((Polygons = (polygon *) malloc(Num_Polygons * sizeof(polygon))) == NULL)
   {
      printf("%s -- can not allocate Polygons. Abort!\n", Subroutine_Name);
      exit(1);
   }

   World -> Polygons = Polygons;

#ifdef DEBUG_GET_WORLD_INFO
   printf("%s - Polygons = 0x%lx\n", Subroutine_Name, World -> Polygons);
#endif

   if ((Vertices = (vertex *) malloc(Num_Vertices * Num_Polygons
                                     * sizeof(vertex))) == NULL)
   {
      printf("%s -- can not allocate Vertices. Abort!\n", Subroutine_Name);
      exit(1);
   }

   World -> Vertices = Vertices;

#ifdef DEBUG_GET_WORLD_INFO
   printf("%s - Vertices = 0x%lx\n", Subroutine_Name, World -> Vertices);
#endif

   for (i = 0, Index = 0; i < Num_Polygons; i++, Index += Num_Vertices)
   {
      Polygons[i].n = Num_Vertices;
      Polygons[i].Vertices = &(Vertices[Index]);
   }

   return(World);
}

view *Get_View_Info(void)
{
   char    *Subroutine_Name = "Get_View_Info()";
   view    *View;
   double  *Pointer;
   int      i;
   int      Index;

   if ((View = (view *) malloc(sizeof(view))) == NULL)
   {
      printf("%s -- can not allocate view. Abort!\n", Subroutine_Name);
      exit(1);
   }

   View -> Num_Eye_Points = 0;
   View -> Current_Eye_Point = 0;

   View -> Eye = NULL;

   View -> Distance_to_Screen = 0;

   View -> Screen.LL_x = 0;
   View -> Screen.LL_y = 0;
   View -> Screen.UR_x = 0;
   View -> Screen.UR_y = 0;

   View -> Near_Plane_Distance = 0;
   View -> Convergence_Distance = 0;

   return(View);
}

eye *Get_Eye_Info(int Num_Eye_Points)
{
   char *Subroutine_Name = "Get_Eye_Info()";
   eye  *Eye;
   int   i;

   if ((Eye = (eye *) malloc(Num_Eye_Points * sizeof(eye))) == NULL)
   {
      printf("%s -- can not allocate eye. Abort!\n", Subroutine_Name);
      exit(1);
   }

   for (i = 0; i < Num_Eye_Points; i++)
   {
      Eye[i].View_direction[X] = 0.0;
      Eye[i].View_direction[Y] = 0.0;
      Eye[i].View_direction[Z] = 0.0;

      Eye[i].Up[X] = 0.0;
      Eye[i].Up[Y] = 0.0;
      Eye[i].Up[Z] = 0.0;

      Eye[i].Location[X] = 0.0;
      Eye[i].Location[Y] = 0.0;
      Eye[i].Location[Z] = 0.0;
   }

   return(Eye);
}

